/*
 *  This file is part of COLLATINVS.
 *                                                                            
 *  COLLATINVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *                                                                            
 *  COLLATINVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *                                                                            
 *  You should have received a copy of the GNU General Public License
 *  along with COLLATINVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suit  330, Boston, MA  02111-1307  USA
 *
 */

#include "ui_collatinus.h"
#include "ui_config.h"
#include <main.h>
#include <QtGui>
//#ifdef Q_WS_WIN
//  #include <QDesktopServices>
//#else
  // pour le mot de passe
extern "C"
{
  #include <crypt.h>
}
//#endif   
// frqences
#include <frequences.h>

// pour dboguer
// #include <QDebug>

/**
 * Bogues : 
 *
 *     encore un problme de limite de mot : le ! est compt dans le mot !
 *
 *     lemmatisation plthorique de certaines formes (romains, f. suffixes).
 *     le ddoublonnage de la lemmatisation d'une suite de formes, au lieu
 *     d'agir sur chaque lemme, agit sur l'ensemble de la lemmatisation
 *     de chaque forme. Pas trs gnant.
 *
 *  implmenter
 *     Aide : appel du navigateur par dfaut ;
 *     Barre d'outils.
 *
 */


//TLexicum* lexicum = new TLexicum ("lemmata.fr");
string uia;
TLexicum*  lexicum = new TLexicum ();
int minRaritas; // degr minimum de raret permettant d'afficher la lemmatisation (de 0  5).
bool morphologia; // autorise/interdit l'affichage des morphologies.

void lexicumLege (string c)
{
    delete lexicum;
    lexicum = new TLexicum (c);
}

QString enTeteLaTeX (
    "\\documentclass[12pt]{article}"
    "\\usepackage[T1]{fontenc}"
    "\\usepackage[latin1]{inputenc}"
    "\\usepackage{pslatex}"
    "\\usepackage{geometry}"
    "\\usepackage[frenchb]{babel}"
    "\\geometry{a4paper, left=1in, right=1in, top=1in, bottom=1in}"
    "\\begin{document}");

QString queueLaTeX ( "\\end{document}");

QString prima (QString l)
{
    QRegExp re ("^\n?(\\w+)");
    int pos = re.indexIn(l);
    if (pos > -1)
       return re.cap (1);
    return "";
}


/**
 * La classe Editeur rimplmente mousePressEvent,
 * qui n'est pas captur par dfaut dans QTextEdit.
 * Oblig d'tre malpropre : dtruire manuellement
 * l'diteur dfini dans le /designer/, et insrer 
 * manuellement au mme emplacement une instance de 
 * cette classe.
 *
 */
Editeur::Editeur (QWidget *parent, const char *name)
: QTextEdit(tr(""), parent)
{
    setAccessibleName(QString::fromUtf8(name));
}

/**
 * Renvoie la lemmatisation de la slection, ou, si elle 
 * est nulle, tout le contenu de l'diteur.
 *
 */
QString Editeur::lemmatiseTxt (bool alpha, bool cumVocibus)
{
    //qDebug () << cumVocibus << endl;
    QString txt = toPlainText ();
    QStringList formes = txt.split (QRegExp("\\W+"), QString::SkipEmptyParts);
    QStringList lemmes;
    QStringList echecs;
    QStringListIterator i (formes);
    QString Retour; 
    QString item;
    QString uox;
    while (i.hasNext ())
    {
       uox = i.next ();
       item = QString::fromStdString (lexicum->lemmatise (uox.toStdString ()));
       QString lemma (prima (item));
       if (frequentia (lemma) < minRaritas)
           continue;
       if (cumVocibus) 
       {
           if (item.size () < uox.size () + 4)
              echecs << item;
           else 
           {
               item.replace ("\n", "\n    ");
               item.insert (1, uox + "\n"); 
               lemmes << item;
           }
       }
       else if (!lemmes.contains (item)) lemmes << item; 
    }
    if (alpha) lemmes.sort ();
    //if (cumVocibus && echecs.size () > 0)
    if (cumVocibus)
    {
        lemmes << "\nHAEC NON RECOGNITA:";
        lemmes << echecs; 
    }
    return lemmes.join ("");
}

void Editeur::mousePressEvent (QMouseEvent *event)
{
    QTextEdit::mousePressEvent (event); 
}

void Editeur::mouseMoveEvent (QMouseEvent *event)
{
    QTextEdit::mouseMoveEvent (event); 
}

void Editeur::mouseReleaseEvent (QMouseEvent *event)
{
    /* implmenter la lemmatisation de la slection 
     * si la touche Maj est enfonce, par exemple,
     * ou la proposer dans un contextuel.
     *
     */
    // poster un signal  l'autre diteur 
    QPoint P = parentWidget()->mapFromGlobal(event->globalPos());
    QTextCursor C = cursorForPosition (P);
    QString ligne = QString::fromStdString (lexicum->lemmatise (motCourant (C).toStdString ()));
    ligne.remove(0,1); // Sale. Il faudrait corriger  la source.
    if (frequentia (prima (ligne)) < minRaritas)
       return;
    // la forme du texte latin demande ?
    emit (copie (ligne));
    //QTextEdit::mousePressEvent (event); 
    QTextEdit::mouseReleaseEvent (event);
}

/**
 * renvoie le mot sous le curseur C
 *
 */
QString Editeur::motCourant (QTextCursor C)
{
    C.movePosition( QTextCursor::StartOfWord, QTextCursor::MoveAnchor );
    C.movePosition( QTextCursor::EndOfWord, QTextCursor::KeepAnchor );
    QString mot = C.selectedText();
    mot.remove (QRegExp ("\\W"));
    return mot; 
}

// dialogue de config, ouverture
void dialogon::ad_raritas (int r)
{
    spinBox->setValue (r);
}

void dialogon::ad_morphologia (bool m)
{
    checkBox->setChecked (m);
}

   // idem, rcupration
dialogon::dialogon ()
{
    setupUi (this);
}

QString dialogon::passe ()
{
    if (lineEdit->text ().isEmpty ()) 
        return "";
    if (lineEdit->text () == lineEdit_2->text ())
       return lineEdit->text ();
    else 
    {
     QMessageBox::warning(this, tr("Collatinus"),
                   tr("duae sesamae differunt !"),
                   QMessageBox::Ok);
   // avertir de la non cohrence
        return "";
    }
}

int dialogon::raritas ()
{
    return spinBox->value ();
}

bool dialogon::morphologia ()
{
    return checkBox->isChecked ();
}

fenestra::fenestra()
{
    setupUi(this);
    delete (EditLatin);
    Ed = new Editeur(splitter, "EditLatin");
    Ed->setObjectName(QString::fromUtf8("EditLatin"));
    QSizePolicy sizePolicy3(static_cast<QSizePolicy::Policy>(13), static_cast<QSizePolicy::Policy>(13));
    setSizePolicy(sizePolicy3);
    setMouseTracking(true);
    splitter->insertWidget(0, EditLatin);
    // pour win : police de Flexio
    #ifdef Q_WS_WIN
    QFont font;
    font.setFamily(QString::fromUtf8("FixedSys"));
    font.setPointSize(9);
    font.setBold(false);
    font.setItalic(false);
    font.setUnderline(false);
    font.setWeight(50);
    font.setStrikeOut(false);
    EditFlexio->setFont(font);
    #endif
    createActions ();
    // droits
    getRights ();
    // chargement du lexique et du fichier d'exemple
    capsamInLatinum ( QString::fromStdString (uia + "lucretia.txt"));
}


void fenestra::decollatino ()
{
    QMessageBox::about(this, tr("De Collatino"),
            tr("COLLATINVS\nLinguae latinae lemmatizatio \n"
               "Licenti GPL, (c) Yves Ouvrard, anno 2006 \n"
               "Versio VIII"));
}

/**
 * cautio retourne Vrai si les diteurs n'ont pas
 * t modifis, ou si l'utilisateur dsire
 * les sauver.
 *
 */
bool fenestra::cautio ()
{
    if (Ed->document()->isModified()
       || EditTextus->document()->isModified() 
       || EditHtml->document()->isModified()
       || EditLaTeX->document()->isModified() ) 
       {
           int ret = QMessageBox::warning(this, tr("Collatinus"),
                   tr("Opus tuum scriptum non est.\n"
                      "Id facere uis nunc ?"),
                   QMessageBox::Yes | QMessageBox::Default,
                   QMessageBox::No,
                   QMessageBox::Cancel | QMessageBox::Escape);
           if (ret == QMessageBox::Yes)
               return scribere ();
           else if (ret == QMessageBox::Cancel)
               return false;
    }
    return true;
}

bool fenestra::capsaminDiscum (const QString &fileName)
{
    int ci = tabWidget->currentIndex ();
    if (ci > 2) return false;
    QFile file(fileName);
    if (!file.open(QFile::WriteOnly | QFile::Text)) {
        QMessageBox::warning(this, tr("Collatinus"),
                             tr("Capsam nequeo scribere %1:\n%2.")
                             .arg(fileName)
                             .arg(file.errorString()));
        return false;
    }

    QTextStream out(&file);
    QApplication::setOverrideCursor(Qt::WaitCursor);
    // selon l'onglet
    if (ci == 0)
    {
        out << Ed->toPlainText();
        out << endl << endl;
        out << EditTextus->toPlainText ();
    }
    else if (ci == 1)
    {
       QString tampon = EditHtml->toHtml ();
       EditHtml->clear ();
       EditHtml->append (Ed->toPlainText ());
       EditHtml->append (tampon);
       out << EditHtml->toHtml ();
       EditHtml->clear ();
       EditHtml->insertHtml (tampon);
    }
    else if (ci == 2)
    {
       out << enTeteLaTeX;
       out << Ed->toPlainText ();
       out << EditLaTeX->toPlainText ();
       out << queueLaTeX;
    }
    QApplication::restoreOverrideCursor();

    daFichierCourant(fileName);
    statusBar()->showMessage(tr("Capsa scripta"), 2000);
    return true;
}

bool fenestra::scribere ()
{
    if (courant.isEmpty()) {
        return scribereVt ();
    } else {
        return capsaminDiscum (courant);
    }
}

bool fenestra::scribereVt ()
{
    QString format, ext;
    switch (tabWidget->currentIndex ())
    {
        case 0:
            format = "textus (*.txt);; quam libet (*)";
            ext = "txt";
            break;
        case 1:
            format = "html (*.html);; quam libet (*)";
            ext = "html";
            break;
        case 2:
            format = "LaTeX (*.tex);; quam libet (*)";
            ext = "tex";
            break;
        default:
            format = "";
    }
     
    QString capsaeNomen = QFileDialog::getSaveFileName (this,"Collatinus - quem capsam ?", "", format);
    if (capsaeNomen.isEmpty())
        return false;
    // s'assurer de l'extension
    QFileInfo fi (capsaeNomen); 
    if (fi.suffix () != ext)
       capsaeNomen = fi.filePath () + "." + ext;
    return capsaminDiscum (capsaeNomen);
}


/**
 * Charge le fichier nomm fileName dans 
 * L'diteur de texte latin (partie suprieure).
 *
 */
void fenestra::capsamInLatinum (const QString &fileName)
{
    QFile file(fileName);
    if (!file.open(QFile::ReadOnly | QFile::Text)) 
    {
        QMessageBox::warning(this, tr("Collatinus"),
                             tr("Capsam legere nequeo %1:\n%2.")
                             .arg(fileName)
                             .arg(file.errorString()));
        return;
    }

    QTextStream in(&file);
    QApplication::setOverrideCursor(Qt::WaitCursor);
    EditLatin->setPlainText(in.readAll());
    QApplication::restoreOverrideCursor();
    daFichierCourant(""); // pour viter d'craser le fichier charg.
    statusBar()->showMessage(tr("Capsa onerata"), 2000);
}

QString fenestra::motCourant (QTextCursor C)
{
    C.movePosition( QTextCursor::StartOfWord, QTextCursor::MoveAnchor );
    C.movePosition( QTextCursor::EndOfWord, QTextCursor::KeepAnchor );
    QString mot = C.selectedText();
    mot.replace (QRegExp ("['\"]"), "");
    return mot; 
}

bool fenestra::event (QEvent *event)
{
    if (event->type () == QEvent::ToolTip && Ed->underMouse ())
    {
        QHelpEvent *helpEvent = static_cast<QHelpEvent *>(event);
        QPoint P = EditLatin->parentWidget()->mapFromGlobal(helpEvent->globalPos());
        QTextCursor muspos = EditLatin->cursorForPosition (P);
        muspos.movePosition( QTextCursor::StartOfWord, QTextCursor::MoveAnchor );
        muspos.movePosition( QTextCursor::EndOfWord, QTextCursor::KeepAnchor );
        QString mot = muspos.selectedText();
        mot = mot.replace (QRegExp ("['\"]"), "");
	QString bulla;
	if (morphologia)
            bulla = QString::fromStdString (lexicum->lemmatiseM (mot.toStdString ()));
	else
            bulla = QString::fromStdString (lexicum->lemmatise (mot.toStdString ()));
        if (frequentia (prima (bulla)) < minRaritas) 
            bulla = "id scire debes"; 
        QToolTip::showText (helpEvent->globalPos(), bulla);
    }
    return QWidget::event (event);
}

/**
 * Renvoie l format en html pour que le 1er mot soit en gras
 */
QString crassaPrima (QString l, int latex=0)
{
    QStringList lineae = l.split ("\n");
    QRegExp re ("^(\\w+)");
    QRegExp refin ("$");
    if (latex)
    {
        lineae.replaceInStrings (re, "\\textbf{\\1}");    
        return lineae.join ("\\\\\n");
    }
    else
    {
        lineae.replaceInStrings (re, "<b>\\1</b>");
        return lineae.join ("<br/>\n");
    }
}

void fenestra::recoisLemm (QString l)
{
    //editeurCourant ()->append (l);
    int ci = tabWidget->currentIndex ();
    if (ci == 0) 
        editeurCourant ()->append (l);
    else if (ci == 1)
    {
        l = crassaPrima (l); 
        EditHtml->append (l);
    }
    else if (ci == 2)
    {
        l = crassaPrima (l, 1);
        EditLaTeX->append (l);
    }
    else if (ci == 3)
    {
        QRegExp re ("^(\\w+)");
        int pos = re.indexIn(l);
        if (pos > -1)
        {
            QString k (re.cap (1));
            Tentree *e = lexicum->entree (k.toStdString ());
            EditFlexio->clear ();
            if (!e->est_vide ())
                EditFlexio->append (QString::fromStdString (lexicum->flechis (e)));
            else EditFlexio->append ("id " + k + " non intellexi.");
        }
    }
}

QTextEdit* fenestra::editeurCourant ()
{
    switch (tabWidget->currentIndex ())
    {
        case 0: return EditTextus;
        case 1: return EditHtml;
        case 2: return EditLaTeX;
        default: return EditFlexio;
    }
}


void fenestra::daFichierCourant (const QString &capsaeNomen)
{
    courant = capsaeNomen;
    EditLatin->document()->setModified(false);
    EditTextus->document()->setModified(false);
    EditHtml->document()->setModified(false);
    EditLaTeX->document()->setModified(false);
    //setWindowModified(false);

    QString nomVisible;
    if (courant.isEmpty())
        nomVisible = "sine_nomine.txt";
    else
        nomVisible = nomSeul (courant);

    setWindowTitle(tr("%1[*] - %2").arg(nomVisible).arg(tr("Collatinus")));
}

QString fenestra::nomSeul (const QString &nomComplet)
{
    return QFileInfo(nomComplet).fileName();
}

/**
 * effacement de tous les diteurs
 * aprs appel ventuel au dialogue
 * de prcaution.
 */
void fenestra::noua ()
{
     if (cautio ())
     {
         Ed->clear ();
         EditTextus->clear ();
         EditHtml->clear ();
         EditLaTeX->clear ();
     }
}

void fenestra::legere()
{
    if (cautio ()) {
        QString capsaeNomen = QFileDialog::getOpenFileName(this);
        if (!capsaeNomen.isEmpty())
            capsamInLatinum (capsaeNomen);
    }
}

void fenestra::lemmataRadere ()
{
    editeurCourant ()->clear (); 
}

void fenestra::closeEvent(QCloseEvent *event)
{
    if (cautio ()) {
        //writeSettings();
        event->accept();
    } else {
        event->ignore();
    }
}


void fenestra::lemmatiseTout ()
{
    editeurCourant ()->clear ();
    int ci = tabWidget->currentIndex ();
    if (ci == 0)
        EditTextus->append (Ed->lemmatiseTxt (
                    actionAlphabetice->isChecked (),
                    actionCum_textus_uocibus->isChecked ()));
    else if (ci == 1)
    {
        QString T = Ed->lemmatiseTxt (
                actionAlphabetice->isChecked (),
                actionCum_textus_uocibus->isChecked ());
        T = crassaPrima (T);
        EditHtml->insertHtml (T); 
    }
    else if (ci == 2)
    {
        QString T = Ed->lemmatiseTxt (
                actionAlphabetice->isChecked (),
                actionCum_textus_uocibus->isChecked ());
        T = crassaPrima (T, 1);
        EditLaTeX->insertPlainText (T); 
    }
}

void fenestra::germanice ()
{
    //lexicumLege ("lemmata.de");
    delete lexicum;
    lexicum = new TLexicum (uia + "lemmata.de");
    actionAnglice->setEnabled (true);
    actionGallice->setEnabled (true);
    actionGermanice->setEnabled (false);
}

void fenestra::gallice ()
{
    //lexicumLege ("lemmata.fr");
    delete lexicum;
    lexicum = new TLexicum (uia + "lemmata.fr");
    actionAnglice->setEnabled (true);
    actionGallice->setEnabled (false);
    actionGermanice->setEnabled (true);
}

void fenestra::anglice ()
{
    //lexicumLege ("lemmata.uk");
    delete lexicum;
    lexicum = new TLexicum (uia + "lemmata.uk");
    actionAnglice->setEnabled (false);
    actionGallice->setEnabled (true);
    actionGermanice->setEnabled (true);
}

void fenestra::inuenire ()
{
    bool ok;
    quaerendum  = QInputDialog::getText(this, tr("Quid quaeris ?"),
                                         tr("Quid quaeris ?"), QLineEdit::Normal,
                                         quaerendum, &ok);
    if (ok && !quaerendum.isEmpty())
        Ed->find (quaerendum);
}

void fenestra::inuenire_denuo ()
{
    if (quaerendum.isEmpty ()) inuenire ();
    else Ed->find (quaerendum);
}

void fenestra::auxilium ()
{
   #ifdef Q_WS_X11
    QFileInfo info (QString::fromStdString (uia + "doc/collatinus.html"));
    QString html;
    if (info.exists ())
        html = "mozilla \"file://" + info.absoluteFilePath () + "\""; 
    else html = "mozilla \"file:///usr/share/doc/collatinus/collatinus.html\"";
    QProcess processus;
    processus.startDetached (html);
    #else
    QDesktopServices::openUrl (QUrl("collatinus.html"));
    #endif
}

/**************
 * api droits
 **************/

void fenestra::setMagisterSum (bool m)
{
    magisterSum = m;
}


/*
void fenestra::setMinRaritas (int r)
{
    minRaritas = r;
}
*/

void fenestra::setLicetMorpho (bool m)
{
    licetMorpho = m;
}

bool fenestra::getMagisterSum ()
{
    return magisterSum;
}

/*
int fenestra::getMinRaritas ()
{
    return minRaritas;
}
*/

bool fenestra::getLicetMorpho ()
{
    return licetMorpho;
}

void fenestra::getRights ()
{
        QString uiaP ("/etc/collatinus/passwd");;
        if (!QFile::exists (uiaP))
            uiaP = QString::fromStdString (uia + "passwd"); 
        QFile fpasse (uiaP);
        if (fpasse.open (QFile::ReadOnly))
        {
            QTextStream In (&fpasse);
            QString linea;
            In >> linea;
            QStringList parametres = linea.split (":");
            minRaritas  = parametres[1].toInt ();
            morphologia = parametres[2].toInt ();
        }
}

void fenestra::setRights ()
{
        QFile fpasse (QString::fromStdString (uia + "passwd"));
        if (fpasse.open (QFile::ReadOnly))
        {
            QTextStream Ad (&fpasse);
            QString linea;
            Ad >> linea;
            QStringList parametres = linea.split (":");
            fpasse.remove ();
            fpasse.open (QFile::WriteOnly);
            parametres[1] = QString::number (minRaritas);
            if (getLicetMorpho ()) parametres[2] = "1";
            else parametres[2] = "0";
            linea = parametres.join (":");
            QTextStream Ab (&fpasse);
            Ab << linea;
            fpasse.close ();
        }
}

void fenestra::setSesama (QString s)
{
        QFile fpasse (QString::fromStdString (uia + "passwd"));
        if (fpasse.open (QFile::ReadOnly))
        {
            QTextStream In (&fpasse);
            QString linea;
            In >> linea;
            QStringList parametres = linea.split (":");
            fpasse.remove ();
            fpasse.open (QFile::WriteOnly);
            QTextStream ex (&fpasse);
	    char * cs = qstrdup (s.toLatin1 ());
            ex << crypt (cs, "LC") << ":" 
               << minRaritas << ":"
               << getLicetMorpho ();
	    delete [] cs;
            fpasse.close ();
        }

}


/**************
 * api droits, fin
 **************/

void fenestra::magister ()
{
    // si magister iam sum, nil pertinet. exeo
    bool magister_sum;
    QString qpasse = QInputDialog::getText(this, tr("sesama"),
                                          "", QLineEdit::Password,
                                          "", &magister_sum);
    if (magister_sum && !qpasse.isEmpty())
    {
        // vrifier la validit du mot de passe
        QFile fpasse (QString::fromStdString (uia + "passwd"));
        if (fpasse.open (QFile::ReadOnly))
        {
            QTextStream In (&fpasse);
            QString linea;
            In >> linea;
            QStringList parametres = linea.split (":");
	    char * cs = qstrdup (qpasse.toLatin1 ());
            if (parametres[0] == crypt (cs, "LC"))
	    //if (true)
            {   
                dialogon D;
                D.ad_raritas (minRaritas);
                D.ad_morphologia (licetMorpho);
                if (D.exec () == QDialog::Accepted)
                {
                     if (!D.passe ().isEmpty ()) 
                         setSesama (D.passe ()); 
                     minRaritas = D.raritas ();
                     morphologia = (D.morphologia ());
                     setRights ();
                }
            }
            fpasse.close ();
	    delete [] cs;
        }
    }
}

void fenestra::createActions ()
{
    connect(action_Noua, SIGNAL(triggered()), Ed, SLOT(clear()));
    connect(action_Noua, SIGNAL(triggered()), this, SLOT(noua()));
    connect (action_Onerare, SIGNAL (triggered ()), this, SLOT (legere ()));
    connect (action_Scribere, SIGNAL (triggered ()), this, SLOT (scribere ()));
    connect (actionScribere_s_ub, SIGNAL (triggered ()), this, SLOT (scribereVt ()));
    connect(actionMaiores_litteras, SIGNAL(triggered()), Ed, SLOT(zoomIn()));
    connect(actionMinores_litteras, SIGNAL(triggered()), Ed, SLOT(zoomOut()));
    connect (actionDe_Collatino, SIGNAL (triggered ()), this, SLOT(decollatino ()));
    connect (actionOmnia_lemmatizare, SIGNAL (triggered ()), this, SLOT(lemmatiseTout ()));
    connect(Ed, SIGNAL(copie (QString)), this, SLOT(recoisLemm (QString)));
    connect(action_Lemmata_radere, SIGNAL(triggered()), this, SLOT(lemmataRadere()));
    connect(actionGermanice, SIGNAL(triggered ()), this, SLOT(germanice ()));
    connect(actionAnglice, SIGNAL(triggered ()), this, SLOT(anglice ()));
    connect(actionGallice, SIGNAL(triggered ()), this, SLOT(gallice ()));
    connect(actionInuenire, SIGNAL(triggered ()), this, SLOT(inuenire ()));
    connect(actionInuenire_etiam, SIGNAL(triggered ()), this, SLOT(inuenire_denuo ()));
    connect(actionAuxilium, SIGNAL(triggered ()), this, SLOT(auxilium ()));
    connect(actionMagister, SIGNAL(triggered ()), this, SLOT(magister ()));
}

int main( int argc, char **argv )
{
    // uia = chemin de l'excutable
    uia = argv[0];
#ifdef Q_WS_WIN
    uia.erase (uia.length () - 14);
#else
    uia.erase (uia.length () - 10);
#endif
    // instanciation effective du lexique;
    delete lexicum;
    //cout << uia + "lemmata.fr" << endl; return 0;
    lexicum = new TLexicum (uia + "lemmata.fr");

    QApplication app(argc, argv);
    //Q_INIT_RESOURCE (collatinus);
    fenestra f;
    f.show();
    return app.exec();
}
