/*
 *                          latinus.cc
 *
 *  This file is part of COLLATINVS.
 *                                                                            
 *  COLLATINVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *                                                                            
 *  COLLATINVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *                                                                            
 *  You should have received a copy of the GNU General Public License
 *  along with COLLATINVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <iostream>
#include <sstream>
#include "libcollatinus.h"

using namespace std;

string lexiciNomen (string nomen, string suffixus)
{
    nomen.replace (nomen.length () - 2, 2, suffixus);
    return nomen;
}

int main (int argc, char* argv[])
{
    string uia (argv[0]);
    uia.replace (uia.length () - 7, uia.length (), "lemmata.fr");  
    TLexicum * lexicum = new TLexicum (uia);
    string requete;
    const int R = 0;
    const int D = 1;
    const int E = 2;
    const int A = 3;
    const int L = 4;
    const int F = 5;
    const string mradical ("radical : ");
    const string mdesinence ("dsinence : ");
    const string mentree ("entre : ");
    const string mforme ("forme latine : ");
    int type = A;

    cout << "Latinus, module texte de Collatinus." << endl;
    cout << "       Pour interroger les radicaux,  ':r'" << endl;
    cout << "                      les dsinences, ':d'" << endl;
    cout << "                         les entres, ':e'" << endl;
    cout << "analyser les formes latines (dfaut), ':a'" << endl;
    cout << "       lemmatiser les formes latines, ':l'" << endl;
    cout << "                  flchir une entre, ':f'" << endl;
    cout << "                         en allemand, ':de'" << endl;
    cout << "                          en anglais, ':uk'" << endl;
    cout << "                         en franais, ':fr'" << endl;
    cout << "                             quitter, 'q'" << endl;
    cout << mforme;

    while (cin >> requete)
    {
        requete = jviu (string (requete));
        if (requete == "q") 
            break;
        else if (requete == ":r")
        {
           type = R;
           cout << mradical;
        }
        else if (requete == ":d")
        {
           type = D;
           cout << mdesinence;
        }
        else if (requete == ":e")
        {
           type = E;
           cout << mentree;
        }
        else if (requete == ":a")
        {
           type = A;
           cout << mforme;
        }
        else if (requete == ":l")
        {
           type = L;
           cout << mforme;
        }
        else if (requete == ":uk")
        {
           delete lexicum;
           lexicum = new TLexicum (lexiciNomen (uia, "uk"));
           cout << mforme;
        }
        else if (requete == ":de")
        {
           delete lexicum;
           lexicum = new TLexicum (lexiciNomen (uia, "de"));
           cout << mforme;
        }
        else if (requete == ":fr")
        {
           delete lexicum;
           lexicum = new TLexicum (lexiciNomen (uia, "fr"));
           cout << mforme;
        }
        else if (requete == ":f")
        {
           type = F;
           cout << mentree;
        }

        else switch (type)
        {
            case R:
                cout << lexicum->radical (requete);
                cout << mradical;
                break;
            case D:
                cout << lexicum->desinence (requete);
                cout << mdesinence;
                break;
            case E:
                cout << lexicum->entree (requete)->doc ();
                cout << endl << mentree;
                break;
            case A:
                cout << lexicum->lemmatiseM (requete);  
                cout << endl << mforme;
                break;
            case L:
                cout << lexicum->lemmatise (requete);
                cout << endl << mforme;
                break;
            case F:
                Tentree *e = lexicum->entree (requete);
                cout << lexicum->flechis (e);
                cout << endl << mentree;
        }
    }
    return 0;
}
